﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Ribbon.Internal;
using Infragistics.Windows.Ribbon;

namespace RibbonButtons
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }


    public partial class ButtonToolProxy : RibbonToolProxy<CustomButtonTool>
    {
        public ButtonToolProxy()
            : base()
        {
        }

     
         protected override void  OnMenuItemClick(CustomButtonTool tool)
    {
         base.OnMenuItemClick(tool);
      MessageBox.Show("Show Something");
    }
  }

    

    public partial class CustomButtonTool : Button, IRibbonTool
    {
        static CustomButtonTool()
        {
            RibbonGroup.MaximumSizeProperty.OverrideMetadata(typeof(CustomButtonTool),
             new FrameworkPropertyMetadata(RibbonToolSizingMode.ImageAndTextNormal));
        }

        protected override void OnClick()
   {
       MessageBox.Show("from custom button");
            base.OnClick();

   }



        #region Common Tool Properties

        #region Id

        /// <summary>
        /// Identifies the Id dependency property.
        /// </summary>
        /// <seealso cref="Id"/>
        public static readonly DependencyProperty IdProperty = RibbonToolHelper.IdProperty.AddOwner(typeof(CustomButtonTool));

        /// <summary>
        /// Returns/sets the Id associated with the tool.
        /// </summary>
        /// <seealso cref="IdProperty"/>
        [System.ComponentModel.Bindable(true)]
        public string Id
        {
            get
            {
                return (string)this.GetValue(CustomButtonTool.IdProperty);
            }
            set
            {
                this.SetValue(CustomButtonTool.IdProperty, value);
            }
        }

        #endregion //Id

        #region Caprion
        public static readonly DependencyProperty CaptionProperty = RibbonToolHelper.CaptionProperty.AddOwner(typeof(CustomButtonTool));

        /// <summary>
        /// Returns/sets the Id associated with the tool.
        /// </summary>
        /// <seealso cref="IdProperty"/>
              [System.ComponentModel.Bindable(true)]
              public string Caption
              {
                  get
                  {
                      return (string)this.GetValue(CustomButtonTool.CaptionProperty);
                  }
                  set
                  {
                      this.SetValue(CustomButtonTool.CaptionProperty, value);
                  }
              }
        #endregion 
        #endregion //Caption

        #region IRibbonTool Members

        public Infragistics.Windows.Ribbon.Internal.RibbonToolProxy ToolProxy
        {
            get
            {
                //throw new Exception("The method or operation is not implemented.");
                return new ButtonToolProxy();
            }
        }

        #endregion
    }

}
